/*
 * The Original Code is the Suffix Array based String Kernel.
 *
 * The Initial Developer of the Original Code is
 * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
 *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
 *
 */


// File    :  sask/Code/ErrorCode.cpp
//
// Authors :  Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
//            S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
//
// Created :  09 Feb 2006
//
// Updated :  24 Apr 2006


#ifndef _ERRORCODE_H_
#define _ERRORCODE_H_

#include "DataType.h"
#include <iostream>

// Verbosity level
enum verbosity {QUIET, INFO, DEBUG};


#define ErrorCode           UInt32

/**
 *  for general use
 */
#define NOERROR             0
#define GENERAL_ERROR       1
#define MEM_ALLOC_FAILED    2
#define INVALID_PARAM       3
#define ARRAY_EMPTY         4
#define OPERATION_FAILED    5

/**
 * SuffixArray
 */
#define MATCH_NOT_FOUND     101
#define PARTIAL_MATCH       102

/**
 * LCP
 */
#define LCP_COMPACT_FAILED  201


#define CHECKERROR(i)       {									           \
	if((i) != NOERROR) {										           \
		std::cout << "[CHECKERROR()]  Error! Code: " << (i) << std::endl;  \
		exit(EXIT_FAILURE);					                               \
	}								                                       \
}


#define MESSAGE(msg) { std::cout<<(msg)<<std::endl; }

#endif
