/*
 * The Original Code is the Suffix Array based String Kernel.
 *
 * The Initial Developer of the Original Code is
 * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
 *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
 *
 */


// File    : sask/Code/ExpDecayWeight.h
//
// Authors : Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
//           S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
//
// Created : 09 Feb 2006
//
// Updated : 24 Apr 2006
//           12 Jul 2006

#ifndef EXPDECAYWEIGHT_H
#define EXPDECAYWEIGHT_H

#include "DataType.h"
#include "ErrorCode.h"
#include "I_WeightFactory.h"
#include <iostream>

class ExpDecayWeight : public I_WeightFactory
{

public:

	Real lambda;

	/// Constructors

  //' NOTE: lambda shouldn't be equal to 1, othexrwise there will be 
  //'         divide-by-zero error.
	ExpDecayWeight(const Real &lambda_=2.0):lambda(lambda_) {}


	/// Destructor
	virtual ~ExpDecayWeight(){}


	/// Compute weight
	ErrorCode ComputeWeight(const UInt32 &floor_len, const UInt32 &x_len, Real &weight);

};
#endif
