/*
 * The Original Code is the Suffix Array based String Kernel.
 *
 * The Initial Developer of the Original Code is
 * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
 *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
 *
 */


// File    : sask/Code/I_LCPFactory.h
//
// Authors : Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
//           S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
//
// Created : 09 Feb 2006
//
// Updated : 24 Apr 2006


#ifndef I_LCPFACTORY_H
#define I_LCPFACTORY_H

#include "DataType.h"
#include "ErrorCode.h"
#include "LCP.h"

class I_LCPFactory
{

 public:

	/// Constructor
	I_LCPFactory(){}

	/// Destructor
	virtual ~I_LCPFactory(){}

	/// Methods
	virtual ErrorCode ComputeLCP(const SYMBOL *text, const UInt32 &length, 
								 const UInt32 *sa,  LCP& lcp) = 0;
	
};
#endif
