/*
 * The Original Code is the Suffix Array based String Kernel.
 *
 * The Initial Developer of the Original Code is
 * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
 *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
 *
 */


// File    : sask/Code/I_SAFactory.h
//
// Authors : Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
//           S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
//
// Created : 09 Feb 2006
//
// Updated : 24 Apr 2006


//' Interface for Enhanced Suffix Array construction algorithms
#ifndef I_SAFACTORY_H
#define I_SAFACTORY_H

#include "DataType.h"
#include "ErrorCode.h"


class I_SAFactory
{

 public:

    ///Constructor
    I_SAFactory(){}
	
	///Destructor
	virtual ~I_SAFactory(){}

	///Methods
	virtual ErrorCode ConstructSA(SYMBOL *text, const UInt32 &len, UInt32 *&array) = 0;

};
#endif
