/*
 * The Original Code is the Suffix Array based String Kernel.
 *
 * The Initial Developer of the Original Code is
 * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
 *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
 *
 */


// File    : sask/Code/I_WeightFactory.h
//
// Authors : Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
//           S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
//
// Created : 09 Feb 2006
//
// Updated : 24 Apr 2006

#ifndef I_WEIGHTFACTORY_H
#define I_WEIGHTFACTORY_H

#include "DataType.h"
#include "ErrorCode.h"


/// Weight Factory interface for string kernel
class I_WeightFactory
{

 public:
	/// Constructor
	I_WeightFactory(){}
	
	/// Destructor
	virtual ~I_WeightFactory(){}

	/// Compute edge weight between floor interval and the end of matched substring.
	virtual ErrorCode ComputeWeight(const UInt32 &floor_len, 
									const UInt32 &x_len,
									Real &weight) = 0;
};
#endif
