/*
 * The Original Code is the Suffix Array based String Kernel.
 *
 * The Initial Developer of the Original Code is
 * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
 *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
 *
 */


// File    : sask/Code/W_kasai_lcp.h
//
// Authors : Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
//           S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
//
// Created : 09 Feb 2006
//
// Updated : 24 Apr 2006


#ifndef W_KASAI_LCP_H
#define W_KASAI_LCP_H

#include "DataType.h"
#include "ErrorCode.h"
#include "I_LCPFactory.h"
#include "LCP.h"

/**
 * Kasai et al's LCP array computation algorithm is
 * is slightly faster than Manzini's algorithm. However,
 * it needs inverse suffix array which costs extra memory.
 */
class W_kasai_lcp : public I_LCPFactory
{

 public:

	/// Constructor
	W_kasai_lcp(){}

	/// Desctructor
	virtual ~W_kasai_lcp(){}

	/// Compute LCP array.
	ErrorCode	ComputeLCP(const SYMBOL *text, const UInt32 &len, 
											 const UInt32 *sa, LCP& lcp);

};
#endif
